//---------------------------------------------------------------------------

#include <vcl.h>
#include <inifiles.hpp>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  AnsiString aux;
  selectedFolder=NULL;
  anclarRaton=false;

TListColumns *ColumnInfo;
ColumnInfo = new TListColumns(ListView1); // Create column headers
ListView1->Columns->Add();
ListView1->Columns->Items[0]->Caption = "Aplicacin";
ListView1->Columns->Items[0]->Width = 200;
ListView1->Columns->Add();
ListView1->Columns->Items[1]->Caption = "cmd";
ListView1->Columns->Items[1]->Width = 150;
ListView1->Columns->Add();
ListView1->Columns->Items[2]->Caption = "icon";
ListView1->Columns->Items[2]->Width = 32;
ListView1->Columns->Add();
ListView1->Columns->Items[3]->Caption = "descr";
ListView1->Columns->Items[3]->Width = 300;


  TIniFile *pIniFile = new TIniFile(ExtractFilePath(Application->ExeName)+"cfg.ini");
  rootPath = pIniFile->ReadString("opciones","rootPATH","");
  if ( rootPath.IsEmpty() ) rootPath = ExtractFileDrive( Application->ExeName );
  pFondoAPP = NULL;
  aux = pIniFile->ReadString("opciones","background","");
  if ( !aux.IsEmpty() )
  {
    aux = ExtractFilePath(Application->ExeName)+AnsiString("\\")+aux;
    if ( FileExists( aux ) )
    {
        pFondoAPP = new TPicture();
        pFondoAPP->LoadFromFile(aux);
    }
  }

  Label3->Caption = pIniFile->ReadString("opciones","titulo","");
  for(int i=0; CreateFolder(i,pIniFile->ReadString("carpetas",AnsiString("c")+i,"")); i++);
  delete pIniFile;

  LoadFolder(0);
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::CreateFolder(int idx,AnsiString name)
{
  TLabel *lb;

  if ( name.IsEmpty() ) return false;

  lb = new TLabel(this);
  lb->Tag = idx;

  lb->OnMouseLeave = LabelsMouseLeave;
  lb->OnMouseMove = LabelsMouseMove;
  lb->OnClick = LabelsClick;

  lb->Caption = name;

  lb->Alignment = taCenter;

  lb->AutoSize = false;
  lb->Height = 18;
  lb->Left = 8;
  lb->Top = 56 + (lb->Height+2)*idx;

  this->InsertControl(lb);
  if ( !selectedFolder ) selectedFolder=lb;

  if ( selectedFolder==lb )
  {
          lb->Width = 168;
          lb->Color=clWhite;
  } else {
          lb->Width = 166;
          lb->Color=clSilver;
  }

  return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LabelsMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  ((TLabel *)Sender)->Color=clSkyBlue;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LabelsMouseLeave(TObject *Sender)
{
  if ( selectedFolder==((TLabel*)Sender) )
  {
          ((TLabel *)Sender)->Color=clWhite;
          ((TLabel *)Sender)->Width = 168;
  } else {
          ((TLabel *)Sender)->Color=clSilver;
          ((TLabel *)Sender)->Width = 166;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LabelsClick(TObject *Sender)
{
  selectedFolder->Width = 166;
  selectedFolder->Color = clSilver;
  selectedFolder=((TLabel*)Sender);
  selectedFolder->Color = clWhite;
  selectedFolder->Width = 168;

  LoadFolder( ((TLabel*)Sender)->Tag );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WMNCHitTest(TMessage &Msg)
{
TForm::Dispatch(&Msg);
/*
if (Msg.Result == HTCLIENT) Msg.Result = HTCAPTION;
*/
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TForm1::LoadFolder(int idx)
{
  TSHFileInfo FileInfo;
  THandle ImageListHandle;
  TIcon *aIcon;

  int i,j;
  AnsiString app,icon;

  ListView1->Items->BeginUpdate(); // Efficiency

  ListView1->Items->Clear();
  ImageList1->Clear();
  ImageList1->ShareImages = false;
  ImageList1->Width=GetSystemMetrics(SM_CXICON);
  ImageList1->Height=GetSystemMetrics(SM_CYICON);


  i=0;
  TIniFile *pIniFile = new TIniFile(ExtractFilePath(Application->ExeName)+"cfg.ini");
  while(1)
  {
   app = pIniFile->ReadString(AnsiString("c")+idx,AnsiString("p")+AnsiString(i)+"_app","");
   if ( app.IsEmpty() ) break;

        ListView1->Items->Add(); // Add a new item
        j = ListView1->Items->Count - 1; // get the new items index

        ListView1->Items->Item[j]->Caption=app; // set the item text
        ListView1->Items->Item[j]->SubItems->Add( rootPath + pIniFile->ReadString(AnsiString("c")+idx,AnsiString("p")+AnsiString(i)+"_cmd","") );
        icon = rootPath + pIniFile->ReadString(AnsiString("c")+idx,AnsiString("p")+AnsiString(i)+"_icon","");
        ListView1->Items->Item[j]->SubItems->Add( icon );
        // Metemos el icono dentro de nuestra ListView...
                memset(&FileInfo, 0, sizeof(FileInfo));
/*
                ImageListHandle = SHGetFileInfo( (char *)icon.data(), 0, &FileInfo, sizeof(FileInfo),
                                                // we want an icon in LARGE
                                                SHGFI_LARGEICON | SHGFI_ICON | SHGFI_ADDOVERLAYS
                                          );
*/
    WORD lpiIcon;
/*
SHSTDAPI_(DWORD_PTR) SHGetFileInfoA(LPCSTR pszPath, DWORD dwFileAttributes, SHFILEINFOA *psfi, UINT cbFileInfo, UINT uFlags);
//-----------------

HICON ExtractAssociatedIcon(          HINSTANCE hInst,
    LPTSTR lpIconPath,
    LPWORD lpiIcon
);
*/
                aIcon = new TIcon();
                aIcon->Handle = ExtractAssociatedIcon(this,(char *)icon.data(),&lpiIcon );
                                        //FileInfo.hIcon;
                aIcon->Transparent = true;

                ListView1->Items->Item[j]->ImageIndex = ImageList1->AddIcon(aIcon);;

        ListView1->Items->Item[j]->SubItems->Add( pIniFile->ReadString(AnsiString("c")+idx,AnsiString("p")+AnsiString(i)+"_descr","") );
//        ListView1->Items->Item[j]->Update();

   i++;
  }
  ListView1->LargeImages = ImageList1;

  ListView1->Items->EndUpdate();

  delete pIniFile;

  return true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListView1DblClick(TObject *Sender)
{
  HINSTANCE HApp;

  // Ejecutamos el ITEM
  TListItem *lItem;
  lItem = ((TListView *)Sender)->Selected;


//   PROCESS_INFORMATION pInfo;
   STARTUPINFO         sInfo;

   sInfo.cb              = sizeof(STARTUPINFO);
   sInfo.lpReserved      = NULL;
   sInfo.lpReserved2     = NULL;
   sInfo.cbReserved2     = 0;
   sInfo.lpDesktop       = NULL;
   sInfo.lpTitle         = NULL;
   sInfo.dwFlags         = 0;
   sInfo.dwX             = 0;
   sInfo.dwY             = 0;
   sInfo.dwFillAttribute = 0;
   sInfo.wShowWindow     = SW_SHOW;
   if (CreateProcess(NULL,
                (char*)((lItem->SubItems->Strings[0]).data()),
                      NULL,
                      NULL,
                      FALSE,
                      0,
                      NULL,
                      (char*)( ExtractFileDir(lItem->SubItems->Strings[0]).data()),
                      &sInfo,
                      &pInfo))
  {
    Application->Minimize();
    Timer1->Enabled=true;
  }
/*
  HApp = ShellExecute(this,	                // handle to parent window
    NULL,		// pointer to string that specifies operation to perform
    (char*)((lItem->SubItems->Strings[0]).data()),			// pointer to filename string
    NULL,		// pointer to string that specifies executable-file parameters
    NULL,		// pointer to string that specifies default directory
    0 			// whether file is shown when opened
   );
*/

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListView1InfoTip(TObject *Sender, TListItem *Item,
      AnsiString &InfoTip)
{
  InfoTip = Item->SubItems->Strings[2];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
 DWORD exitCode;
   if (GetExitCodeProcess(pInfo.hProcess, &exitCode))
   {
      switch(exitCode)
      {
         case STILL_ACTIVE: //printf("Process is still active\n");
                            break;
         default:           //printf("Exit code = %d\n", exitCode);
                            Application->Restore();
                            Timer1->Enabled = false;
                            break;
      }
   }
   else {
//      printf("GetExitCodeProcess() failed\n");
      Application->Restore();
      Timer1->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
  Application->Minimize();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 if (pFondoAPP)
 {
         delete pFondoAPP;
         pFondoAPP = NULL;
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
 if ( pFondoAPP && pFondoAPP->Graphic && !pFondoAPP->Graphic->Empty )
  Canvas->Draw(0,0,pFondoAPP->Graphic);
}
//---------------------------------------------------------------------------


